(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngxf-uploader', ['exports', '@angular/core', '@angular/common/http', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngxf-uploader'] = {}, global.ng.core, global.ng.common.http, global.rxjs, global.rxjs.operators));
}(this, (function (exports, i0, i1, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    function getUploadResult(files, accept, multiple, option) {
        if (multiple !== undefined) {
            return checkAllFile(files, accept, option);
        }
        if (files.length === 1) {
            return checkAllFile(files[0], accept, option);
        }
        return 0 /* NumError */;
    }
    function checkAllFile(file, accept, option) {
        if (file instanceof FileList || file instanceof Array) {
            var files_1 = [];
            var err_1;
            var allPass = Array.from(file).every(function (f) {
                var error = checkOneFile(f, accept, option);
                var noError = error instanceof File;
                err_1 = error;
                if (noError) {
                    files_1.push(f);
                }
                // if skipInvalid, all pass
                return option.skipInvalid || noError;
            });
            if (!allPass) {
                return err_1;
            }
            return files_1;
        }
        return checkOneFile(file, accept, option);
    }
    function checkOneFile(file, accept, option) {
        if (!checkFileType(file, accept)) {
            return 1 /* TypeError */;
        }
        if (!checkFileSize(file, option)) {
            return 2 /* SizeError */;
        }
        return file;
    }
    function checkFileType(file, accept) {
        if (accept) {
            var acceptedFilesArray = accept.split(',');
            return acceptedFilesArray.some(function (type) {
                var validType = type.trim();
                if (validType.charAt(0) === '.') {
                    return file.name.toLowerCase().endsWith(validType.toLowerCase());
                }
                else if (/\/\*$/.test(validType)) {
                    // This is something like a image/* mime type
                    return (file.type.replace(/\/.*$/, '') === validType.replace(/\/.*$/, ''));
                }
                return file.type === validType;
            });
        }
        return true;
    }
    function checkFileSize(file, option) {
        if (option) {
            var size = file.size;
            var chkSize = option.size;
            if (chkSize &&
                ((chkSize.min && size < chkSize.min) ||
                    (chkSize.max && size > chkSize.max))) {
                return false;
            }
        }
        return true;
    }

    var getFilesFromEntry = function (entry, path) {
        if (path === void 0) { path = ''; }
        return __awaiter(void 0, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!entry.isDirectory) return [3 /*break*/, 2];
                        return [4 /*yield*/, readDir(entry, path)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, readFile(entry, path)];
                    case 3:
                        _a = [_b.sent()];
                        _b.label = 4;
                    case 4: return [2 /*return*/, _a];
                }
            });
        });
    };
    var ɵ0 = getFilesFromEntry;
    var readFile = function (entry, path) {
        if (path === void 0) { path = ''; }
        return new Promise(function (resolve, reject) {
            entry.file(function (file) {
                file.filepath = path + file.name;
                resolve(file);
            }, reject);
        });
    };
    var ɵ1 = readFile;
    var readDir = function (entry, path) { return __awaiter(void 0, void 0, void 0, function () {
        var dirReader, newPath, files, newFiles;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dirReader = entry.createReader();
                    newPath = path + entry.name + "/";
                    files = [];
                    _a.label = 1;
                case 1: return [4 /*yield*/, dirReadEntries(dirReader, newPath)];
                case 2:
                    newFiles = _a.sent();
                    files = files.concat(newFiles);
                    _a.label = 3;
                case 3:
                    if (newFiles.length > 0) return [3 /*break*/, 1];
                    _a.label = 4;
                case 4: return [2 /*return*/, files];
            }
        });
    }); };
    var ɵ2 = readDir;
    var dirReadEntries = function (dirReader, path) {
        return new Promise(function (resolve, reject) {
            dirReader.readEntries(function (entries) { return __awaiter(void 0, void 0, void 0, function () {
                var files, entries_1, entries_1_1, entry, itemFiles, e_1_1;
                var e_1, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            files = [];
                            _b.label = 1;
                        case 1:
                            _b.trys.push([1, 6, 7, 8]);
                            entries_1 = __values(entries), entries_1_1 = entries_1.next();
                            _b.label = 2;
                        case 2:
                            if (!!entries_1_1.done) return [3 /*break*/, 5];
                            entry = entries_1_1.value;
                            return [4 /*yield*/, getFilesFromEntry(entry, path)];
                        case 3:
                            itemFiles = _b.sent();
                            files = files.concat(itemFiles);
                            _b.label = 4;
                        case 4:
                            entries_1_1 = entries_1.next();
                            return [3 /*break*/, 2];
                        case 5: return [3 /*break*/, 8];
                        case 6:
                            e_1_1 = _b.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 8];
                        case 7:
                            try {
                                if (entries_1_1 && !entries_1_1.done && (_a = entries_1.return)) _a.call(entries_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 8:
                            resolve(files);
                            return [2 /*return*/];
                    }
                });
            }); }, reject);
        });
    };
    var ɵ3 = dirReadEntries;
    /** get files from `webkitGetAsEntry` */
    var getFilesFromGetAsEntry = function (e) { return __awaiter(void 0, void 0, void 0, function () {
        var files, items, i, entry, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    files = [];
                    items = e.dataTransfer.items;
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < items.length)) return [3 /*break*/, 4];
                    entry = items[i].webkitGetAsEntry();
                    return [4 /*yield*/, getFilesFromEntry(entry)];
                case 2:
                    result = _a.sent();
                    files.push.apply(files, __spread(result));
                    _a.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, files];
            }
        });
    }); };

    var stopEvent = function (e) {
        e.stopPropagation();
        e.preventDefault();
    };
    var ɵ0$1 = stopEvent;
    /**
     * provide a directive for you to set area can be drop file into
     */
    var NgxfDropDirective = /** @class */ (function () {
        function NgxfDropDirective(_elm, _render) {
            this._elm = _elm;
            this._render = _render;
            /** when get drop file into area that will trigger */
            this.onUpload = new i0.EventEmitter();
            this.fileOption = {};
            /**
             * add class when drop into this drop area
             * @default 'drop'
             */
            this.dropClass = 'drop';
        }
        NgxfDropDirective.prototype.drop = function (e) {
            return __awaiter(this, void 0, void 0, function () {
                var files, error_1, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            stopEvent(e);
                            this._render.removeClass(this._elm.nativeElement, this.dropClass);
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, getFilesFromGetAsEntry(e)];
                        case 2:
                            files = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            error_1 = _a.sent();
                            files = e.dataTransfer.files;
                            return [3 /*break*/, 4];
                        case 4:
                            result = getUploadResult(files, this.accept, this.multiple, this.fileOption);
                            this.onUpload.emit(result);
                            return [2 /*return*/];
                    }
                });
            });
        };
        NgxfDropDirective.prototype.dragenter = function (e) {
            stopEvent(e);
            this._render.addClass(this._elm.nativeElement, this.dropClass);
        };
        NgxfDropDirective.prototype.dragleave = function (e) {
            stopEvent(e);
            this._render.removeClass(this._elm.nativeElement, this.dropClass);
        };
        return NgxfDropDirective;
    }());
    NgxfDropDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngxf-drop]',
                },] }
    ];
    NgxfDropDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 }
    ]; };
    NgxfDropDirective.propDecorators = {
        onUpload: [{ type: i0.Output, args: ['ngxf-drop',] }],
        fileOption: [{ type: i0.Input, args: ['ngxf-validate',] }],
        multiple: [{ type: i0.Input }],
        accept: [{ type: i0.Input }],
        dropClass: [{ type: i0.Input, args: ['drop-class',] }],
        drop: [{ type: i0.HostListener, args: ['drop', ['$event'],] }],
        dragenter: [{ type: i0.HostListener, args: ['dragover', ['$event'],] }, { type: i0.HostListener, args: ['dragenter', ['$event'],] }],
        dragleave: [{ type: i0.HostListener, args: ['dragleave', ['$event'],] }]
    };

    /**
     * provide a directive that can let you select file upload by click
     */
    var NgxfSelectDirective = /** @class */ (function () {
        function NgxfSelectDirective(_render, _elm) {
            this._render = _render;
            this._elm = _elm;
            /** when use select some files end, that will trigger */
            this.uploadOutput = new i0.EventEmitter();
            this.fileOption = {};
        }
        NgxfSelectDirective.prototype.click = function () {
            this.bindBeforeClick();
            this.fileElm.click();
        };
        NgxfSelectDirective.prototype.ngAfterViewInit = function () {
            this.fileElm = this._render.createElement('input');
            this._render.setAttribute(this.fileElm, 'type', 'file');
            this._render.setStyle(this.fileElm, 'display', 'none');
            if (this.folder !== undefined && this.multiple !== undefined) {
                this._render.setAttribute(this.fileElm, 'webkitdirectory', '');
            }
            this._render.appendChild(this._elm.nativeElement.parentNode, this.fileElm);
        };
        NgxfSelectDirective.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this.changeListen) === null || _a === void 0 ? void 0 : _a.call(this);
            this._render.removeChild(this._elm.nativeElement.parentNode, this.fileElm);
        };
        // because bind before click, that can change input to change accept and validate
        NgxfSelectDirective.prototype.bindBeforeClick = function () {
            var _this = this;
            var _a;
            if (this.multiple !== undefined) {
                this._render.setAttribute(this.fileElm, 'multiple', '');
            }
            else {
                this._render.removeAttribute(this.fileElm, 'multiple');
            }
            this._render.setAttribute(this.fileElm, 'accept', this.accept);
            (_a = this.changeListen) === null || _a === void 0 ? void 0 : _a.call(this);
            this.changeListen = this._render.listen(this.fileElm, 'change', function (e) {
                var _a, _b, _c;
                // when length is more than 0
                if ((_b = (_a = _this.fileElm) === null || _a === void 0 ? void 0 : _a.files) === null || _b === void 0 ? void 0 : _b.length) {
                    var result = getUploadResult(_this.fileElm.files, _this.accept, _this.multiple, _this.fileOption);
                    _this.uploadOutput.emit(result);
                }
                _this.fileElm.value = '';
                (_c = _this.changeListen) === null || _c === void 0 ? void 0 : _c.call(_this);
            });
        };
        return NgxfSelectDirective;
    }());
    NgxfSelectDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngxf-select]',
                },] }
    ];
    NgxfSelectDirective.ctorParameters = function () { return [
        { type: i0.Renderer2 },
        { type: i0.ElementRef }
    ]; };
    NgxfSelectDirective.propDecorators = {
        uploadOutput: [{ type: i0.Output, args: ['ngxf-select',] }],
        fileOption: [{ type: i0.Input, args: ['ngxf-validate',] }],
        multiple: [{ type: i0.Input }],
        accept: [{ type: i0.Input }],
        folder: [{ type: i0.Input }],
        click: [{ type: i0.HostListener, args: ['click',] }]
    };

    /**
     * provide a directive for you to set area can be parse file into
     */
    var NgxfParseDirective = /** @class */ (function () {
        function NgxfParseDirective() {
            /** when get parse file that will trigger */
            this.uploadOutput = new i0.EventEmitter();
            this.fileOption = {};
        }
        NgxfParseDirective.prototype.parse = function (event) {
            var clipboardData = event.clipboardData;
            if ((clipboardData === null || clipboardData === void 0 ? void 0 : clipboardData.files.length) === 0)
                return;
            var result = getUploadResult(clipboardData === null || clipboardData === void 0 ? void 0 : clipboardData.files, this.accept, this.multiple, this.fileOption);
            this.uploadOutput.emit(result);
        };
        return NgxfParseDirective;
    }());
    NgxfParseDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngxf-parse]',
                },] }
    ];
    NgxfParseDirective.propDecorators = {
        uploadOutput: [{ type: i0.Output, args: ['ngxf-parse',] }],
        fileOption: [{ type: i0.Input, args: ['ngxf-validate',] }],
        multiple: [{ type: i0.Input }],
        accept: [{ type: i0.Input }],
        parse: [{ type: i0.HostListener, args: ['paste', ['$event'],] }]
    };

    var NgxfUploaderService = /** @class */ (function () {
        function NgxfUploaderService(http) {
            this.http = http;
        }
        /**
         * a method provide you to upload file through api easily.
         * @param option that upload detail options
         * @returns `UploadEvent` observable that combine with `status`, `percent`, `data`
         */
        NgxfUploaderService.prototype.upload = function (option) {
            var files = option.files, _a = option.method, method = _a === void 0 ? 'POST' : _a, url = option.url, headers = option.headers, params = option.params, process = option.process, filesKey = option.filesKey, fields = option.fields, rest = __rest(option, ["files", "method", "url", "headers", "params", "process", "filesKey", "fields"]);
            if (files instanceof Blob ||
                files instanceof File ||
                (files instanceof Array && files.length !== 0)) {
                var uploadData = objectToFormData(option);
                var request = new i1.HttpRequest(method, url, uploadData, Object.assign({ headers: headers instanceof i1.HttpHeaders ? headers : new i1.HttpHeaders(headers), params: params instanceof i1.HttpParams
                        ? params
                        : new i1.HttpParams({ fromObject: params }), reportProgress: process }, rest));
                return this.http.request(request).pipe(operators.filter(function (response) {
                    if (process) {
                        return !(response instanceof i1.HttpHeaderResponse ||
                            response.type === i1.HttpEventType.DownloadProgress);
                    }
                    return response.type === i1.HttpEventType.Response;
                }), operators.map(function (event) {
                    switch (event.type) {
                        case i1.HttpEventType.Sent:
                            return {
                                status: 0 /* Uploading */,
                                percent: 0,
                            };
                        case i1.HttpEventType.UploadProgress:
                            return {
                                status: 0 /* Uploading */,
                                percent: Math.round((100 * event.loaded) / event.total) || 0,
                            };
                        case i1.HttpEventType.Response:
                            return {
                                status: 1 /* Completed */,
                                percent: 100,
                                data: event.body,
                            };
                        default:
                            return {};
                    }
                }), operators.catchError(function (error) {
                    return rxjs.throwError({
                        status: 2 /* UploadError */,
                        data: error.error,
                    });
                }));
            }
            return rxjs.throwError({ status: 3 /* FileNumError */ });
        };
        return NgxfUploaderService;
    }());
    NgxfUploaderService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxfUploaderService_Factory() { return new NgxfUploaderService(i0.ɵɵinject(i1.HttpClient)); }, token: NgxfUploaderService, providedIn: "root" });
    NgxfUploaderService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgxfUploaderService.ctorParameters = function () { return [
        { type: i1.HttpClient }
    ]; };
    var defaultFileKey = 'file';
    function objectToFormData(_a) {
        var fields = _a.fields, files = _a.files, filesKey = _a.filesKey;
        var data = new FormData();
        // * add fields
        if (fields) {
            Object.keys(fields).forEach(function (key) { return data.append(key, fields[key]); });
        }
        // * add files
        if (files instanceof Blob || files instanceof File) {
            data.append(filesKey || defaultFileKey, files, files['name'] || 'blob');
        }
        else {
            for (var i = 0; i < files.length; i++) {
                var key = defaultFileKey;
                // * if it has key
                if (filesKey) {
                    if (filesKey instanceof Array) {
                        key = filesKey[i % filesKey.length];
                    }
                    else {
                        key = filesKey;
                    }
                }
                data.append(key, files[i], files[i]['name'] || "blob" + i);
            }
        }
        return data;
    }

    /**
     * ### ngxf-upload
     *
     * A file upload module provide you can upload file easily
     */
    var NgxfUploaderModule = /** @class */ (function () {
        function NgxfUploaderModule() {
        }
        return NgxfUploaderModule;
    }());
    NgxfUploaderModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgxfSelectDirective, NgxfDropDirective, NgxfParseDirective],
                    exports: [NgxfSelectDirective, NgxfDropDirective, NgxfParseDirective],
                },] }
    ];

    /*
     * Public API Surface of ngxf-uploader
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxfDropDirective = NgxfDropDirective;
    exports.NgxfParseDirective = NgxfParseDirective;
    exports.NgxfSelectDirective = NgxfSelectDirective;
    exports.NgxfUploaderModule = NgxfUploaderModule;
    exports.NgxfUploaderService = NgxfUploaderService;
    exports.ɵ0 = ɵ0$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngxf-uploader.umd.js.map
