import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { UploadEvent, UploadObject } from './ngxf-uploader.model';
export declare class NgxfUploaderService {
    private http;
    constructor(http: HttpClient);
    /**
     * a method provide you to upload file through api easily.
     * @param option that upload detail options
     * @returns `UploadEvent` observable that combine with `status`, `percent`, `data`
     */
    upload(option: UploadObject): Observable<UploadEvent>;
}
